<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: morse_bbcode_include.php
| Author: Sharky
| Website: http://www.sharky-creations.com
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }
$count = preg_match_all('#\[morse\](.*?)\[/morse\]#si', $text, $matchm, PREG_PATTERN_ORDER);
for($i=0; $i<$count; $i++) {
$tocode=$matchm[1][$i];
$morse_code = array(
        'A' => '.-',
        'B' => '-...',
        'C' => '-.-.',
        'D' => '-..',
        'E' => '.',
        'F' => '..-.',
        'G' => '--.',
        'H' => '....',
        'I' => '..',
        'J' => '.---',
        'K' => '-.-',
        'L' => '.-..',
        'M' => '--',
        'N' => '-.',
        'O' => '---',
        'P' => '.--.',
        'Q' => '--.-',
        'R' => '.-.',
        'S' => '...',
        'T' => '-',
        'U' => '..-',
        'V' => '...-',
        'W' => '.--',
        'X' => '-..-',
        'Y' => '-.--',
        'Z' => '--..',
        '0' => '-----',
        '1' => '.----',
        '2' => '..---',
        '3' => '...--',
        '4' => '....-',
        '5' => '.....',
        '6' => '-....',
        '7' => '--...',
        '8' => '---..',
        '9' => '----.',
        '\%' => '.-.-.-',// % represents the dot
        '\,' => '--..--',
        '\:' => '---...',
        '\;' => '-.-.-.',
        '\?' => '..--..',
        "\'" => '.----.',
        '\!' => '-.-.--',
        '\+' => '.-.-.',
        '\~' => '-....-',// ~ represents the dash
        '\_' => '..--.-',
        '\/' => '-..-.',
        '\(' => '-.--.',
        '\)' => '-.--.-',
        '\$' => '...-..-',
        '\"' => '.-..-.',
        '\@' => '.--.-.',
        '\&' => '.-...',
        '\=' => '-...-'
        ); 
$tocode = strtoupper($tocode);
$tocode = preg_replace("/\./", "%", $tocode);
$tocode = preg_replace("/\-/", "~", $tocode);
$tocode = preg_replace("/[[:space:]]/", "^", $tocode);
foreach ($morse_code as $code => $morse) {
    $tocode = preg_replace("/".$code."/", " ".$morse." ", $tocode);
}
$tocode = preg_replace("/\^/", " / ", $tocode);
$text = str_replace($matchm[0][$i], "Morse:<br><div style='border-width:thin; border-style:solid; font-size: 12pt; word-spacing: 0.53em; letter-spacing: 0.2em;'>
".$tocode."</div>", $text);
}
?>